function LocalStorage(dir, file) {
  this.fileDir = dir; // TODO: use widget.id. What is it ? 0_j
  this.filePath = dir + '/' + file;
  this.fs = new FileSystem();

  this.storage = this.read() || {};
  alert("@@@ LoaclStorage.ctor() storage " + objToString(this.storage));
}

// public
LocalStorage.prototype.get = function(key) {
  //return null;
  return this.storage[key];
}

// public
LocalStorage.prototype.set = function(key, value) {
  this.storage[key] = value;
  this.save();
}

// private
LocalStorage.prototype.save = function() {
  if (!this.hasDir(this.fileDir)) {
    this.fs.createCommonDir(this.fileDir); // return Boolean
  }
  var f = this.fs.openCommonFile(this.filePath, 'w');
  f.writeAll($.toJSON(this.storage));
  this.fs.closeCommonFile(f);
}

// private 
LocalStorage.prototype.read = function() {
  var content = null;
  if (this.hasDir(this.fileDir)) {
    var f = this.fs.openCommonFile(this.filePath, 'a+');
    var s = f.readAll();
    content = {authToken: s};
    try {
      content = $.evalJSON(s);
    } catch(e) {
    }
    this.fs.closeCommonFile(f);
  }
  return content;  
}

// private
LocalStorage.prototype.hasDir = function(dir) {
  // fs api returns: 0 - js error, 1 - valid, 2 - invalid
  return (1 == this.fs.isValidCommonPath(dir));
}
