function Telecasts(proxy) {
  this.proxy = proxy;
  this.telecasts = [];
}

// public
// config {
//   update: boolean, get from server forced (default false)
//   sync: boolean (default false), N.B.: it locks the app
//   callback: {scope, fn}
//   start: int, start index (default 0)
//   count: int,
//   channel
//}
Telecasts.prototype.get = function(config) {
  var c = $.extend({update: false, sync: false, start:0}, config);

  if (c.update) {
    this.telecasts = [];
    this.totalCount = null;
    c.update = false;
  }

  if (this.channel && this.channel.abbr == c.channel.abbr && 0 < this.telecasts.length || c.prevLoadFailed) {
    this.getTelecastsResult = this.getTelecasts(c.start, c.count);
    c.callback && c.callback.fn.call(c.scope, this.getTelecastsResult);
  } else {
    this.channel = c.channel;
    var self = this;
    this.proxy.getTelecasts(c.channel.abbr, {scope: self,
      fn: function(success, result) {
        self.onTelecastsLoaded(success, result);
        c.prevLoadFailed = !(success && result);
        this.getTelecastsResult = self.get(c);
      }
    }, {sync: c.sync});
  }

  return this.getTelecastsResult;
}

// public
Telecasts.prototype.totalCount = function() {
  return this.totalCount;
}


// private callback
Telecasts.prototype.onTelecastsLoaded = function(success, result) {
  if (success && result) {
    if (result.timeshift) {
      this.telecasts = result.timeshift;
      this.totalCount = this.telecasts.length;
      for (var i = 0; i < this.totalCount; i++) {
        this.telecasts[i].width = this.channel.width;
        this.telecasts[i].height = this.channel.height;
        this.telecasts[i].streamUrls = this.telecasts[i][AppInfo.streamUrlsPrefix() + "_urls"];
      }
    }
  }
}

// private
Telecasts.prototype.getTelecasts = function(start, count) {
  var t = null;
  if (start < this.totalCount) {
    t = [];
    var endIndex = Math.min(start + (count || this.totalCount), this.totalCount);
    for (var i = start; i < endIndex; i++) {
      t.push(this.telecasts[i]);
    }
  }
  return t;
}

