function Version(proxy) {
  this.proxy = proxy;
  this.version = null;
}

// public
// config {
//   update: boolean, get from server forced (default false)
//   sync: boolean (default false), N.B.: it locks the app
//   callback: {scope, fn}
//}
Version.prototype.get = function(config) {
  var c = $.extend({update: false, sync: false}, config);
  if (c.update) {
    c.update = false;
    this.version = null;
  }
  this.version = this.version || {};
  this.version.curVersion = this.version.curVersion || Settings.curVersion;
  if ((this.version && this.version.lastVersion && !c.update) || c.prevLoadFailed) {
    c.callback && c.callback.fn.call(c.scope, this.version);
  } else {
    var self = this;
    this.proxy.getLastVersion({scope: self,
      fn: function(success, result) {
        c.prevLoadFailed = !self.onLastVersionLoaded(success, result);
        this.version = self.get(c);
      }
    }, {sync: c.sync});
  }

  return this.version;
}

// private callback
Version.prototype.onLastVersionLoaded = function(success, result) {
  if (success && result) {
    if (result.lastVersion) {
       this.version.lastVersion = result.lastVersion;
       return true;
    }
  }
  return false;
}


