/**
 * config : {
 *   styles: Array, REQUIRED
 *   states:  Array,
 *   ... concrete STATE: pair of name(String):value(Int) (for example MUTED: 1)
 * }
 * default states: OFF = 0, ON = 1;
 */
function ToggleButton(rootEl, config) {
  // defaults
  this.OFF = 0;
  this.ON = 1;
  this.states = [this.OFF, this.ON];

  $.extend(true, this, config);

  this.rootEl = rootEl;

  this.setState(this.OFF);
}

ToggleButton.prototype.setState = function(state) {
  removeStyleClassFromEl(this.styles[this.curState], this.rootEl);
  this.curState = state % this.states.length;
  addStyleClassToEl(this.styles[this.curState], this.rootEl);
}

ToggleButton.prototype.toggleState = function() {
  this.setState(this.curState + 1);
}