function LoginErrorScreen(config) {
  ErrorScreen.call(this, config);
}

LoginErrorScreen.inheritsFrom(ErrorScreen);

/**
 * config: screen config  + {
 *   authResult,
 *   errorDescription (RequestErrors)
 * }
 */
// protected override
LoginErrorScreen.prototype.selectBehavior = function(config) {
  var c = config || {};
  var self = this;
  var behavior = {template: 'templates/notification.ejs',
    info: { buttons: [{label: Locale.t('LoginError.Exit'), callback: {scope: self, fn: self.exitApp}, naviId: 'NotificationScreen.btExit'}],
      message: '' }};
  switch (c.authResult) {
    case AuthResults.SUBSCRIPTION_INACTIVE:
      behavior.info.message = Locale.t('LoginError.SubscriptionInactive');
      break;
    case AuthResults.STB_INACTIVE:
      behavior.info.message = Locale.t('LoginError.StbInactive');
      break;
    case AuthResults.CONFIRM_TOKEN_FAIL:
      behavior.info.message = Locale.t('LoginError.ConfirmTokenFail');
      behavior.info.buttons = [{label:Locale.t('LoginError.Retry')
        , callback:{scope:self, fn: self.retryRequestToken}, naviId: 'NotificationScreen.btRetry'}];
      break;
    case AuthResults.NETWORK_ERROR:
      behavior.info.message = this.getRequestErrorMessage(c.errorDescription);;
      break;
    default:
      break;
  }
  return behavior;
}

// private
LoginErrorScreen.prototype.exitApp = function() {
  widgetAPI.sendReturnEvent();
}

// private
LoginErrorScreen.prototype.retryRequestToken = function() {
  TVPApp.authorize();
}
