function QueueScreen(config) {
  Screen.call(this, config);
  this.model = ModelsFactory.getQueue();
}

QueueScreen.inheritsFrom(Screen);


// public override
QueueScreen.prototype.getNaviButtons = function() {
  var nb = this.naviButtons.concat({name: NavigationButtons.GREEN, text: Locale.t('HB.Reload')});
  if (this.filmsPagedDisplay && this.filmsPagedDisplay.hoveredItem) {
    return nb.concat({name: NavigationButtons.YELLOW, text: Locale.t('Film.Menu.RemoveFromQueue')});
  }
  return nb;
}


QueueScreen.prototype.keyHandler = function(keyEvent) {
  switch(keyEvent.keyCode) {
    case tvKey.KEY_YELLOW:
      if (this.filmsPagedDisplay.hoveredItem) {
        var self = this;
        this.model.removeFromQueue({film: this.filmsPagedDisplay.hoveredItem.info, callback: {scope: self,
          fn: function(success, films) {
            if (success) {
              self.films = films;
              self.filmsPagedDisplay.updatePage({source: self.films});
              WidgetsFactory.getNaviHelp().updateNavi(self.getNaviButtons());
            }
          }
        }});
      }
      break;
    case tvKey.KEY_GREEN:
      var self = this;
      this.model.get({ update: true, callback: { scope: self,
        fn: function(films) {
          self.displayFilms(films);
        }
      }});
      break;
    default:
      break;
  }

  WidgetsFactory.getNaviHelp().updateNavi(this.getNaviButtons());
};

// protected override
QueueScreen.prototype.fill = function(config) {
  var self = this;
  this.model.get({callback: {scope: self,
    fn: function(films) {
      if (films || 0 == self.model.totalCount) {
        alert("QueueScreen.fill() films " + films);
        self.displayFilms(films);
        self.onFillComplete(config.focused);
      }
    }
  }});
};

// private
QueueScreen.prototype.displayFilms = function(films) {
   this.filmsPagedDisplay = WidgetsFactory.queueScreen.getFilmsPagedDisplay({
    rootEl: this.rootEl,
    model: this.model
  });

  var self = this;
  $(this.filmsPagedDisplay).bind(Events.NAVI_SELECTION_SET,
    function(event, selectedContentItem) {
      self.onFilmSelected(selectedContentItem);
    });

  this.setupNavi([[this.filmsPagedDisplay]]);
  this.setCurEl();
  this.filmsPagedDisplay.showPage();
}

// private callback
QueueScreen.prototype.onFilmSelected = function(film) {
  alert("QueueScreen.onFilmSelected() " + objToString(film));
  this.childScreen = WidgetsFactory.getScreen(ScreenTypes.FILM, {parentScreen: this});
  this.childScreen.show({film: film.info});
}




