function WaitingScreen(config) {
  Screen.call(this, config);
  var self = this;
  $(this).bind(Events.NAVI_SELECTION_SET
    , function(event, selectedButton) {
        self.buttonHandler();
  });
}

WaitingScreen.inheritsFrom(Screen);

// public override
WaitingScreen.prototype.return = function() {
  this.callbackNeeds = true;
  Screen.prototype.return.call(this);
}


// protected override
WaitingScreen.prototype.fill = function(config) {
  var content = {
    buttons: [{label: Locale.t('Waiting.Cancel'), naviId: 'WaitingScreen.btCancel'}],
    message: config.message
  };

  this.callback = config.callback;

  var html = new EJS({url: 'templates/notification.ejs'}).render(content);
  widgetAPI.putInnerHTML(this.rootEl, html);

  this.setupNavi([[{naviId: 'WaitingScreen.btCancel'}]]);
  this.setCurEl();

  this.onFillComplete(config.focused);
}

// protected override
WaitingScreen.prototype.beforeHide = function() {
  var call = this.callback && this.callbackNeeds;
  this.callbackNeeds = false;
  if (call) {
    this.callback.fn.call(this.callback.scope);
  }
  this.callback = null;
}

WaitingScreen.prototype.buttonHandler = function() {
  this.callbackNeeds = true;
  this.hide();
}

